src/CentraleLille/CustomFosUserBundle/Entity/ProjectableUserInterface.php
<?php
/**
 * Created by PhpStorm.
 * User: alex
 * Date: 3/5/16
 * Time: 5:22 PM
 */

namespace CentraleLille\CustomFosUserBundle\Entity;

interface ProjectableUserInterface
{

    /**
     * Gets the user's projects.
     *
     * @return \Traversable
     */
    public function getProjectUsers();

    /**
     * Gets the name of the projects which include the user.
     *
     * @return array
     */
    public function getProjectNames();


    /**
     * Indicates whether the user belongs to the specified project or not.
     *
     * @param string $name Name of the project
     *
     * @return Boolean
     */
    public function hasProject($name);

//    /**
//     * Add a project to the user projects.
//     *
//     * @param Project $project
//     *
//     * @return self
//     */
//    public function addProject($project);
//
//    /**
//     * Remove a project from the user projects.
//     *
//     * @param Project $project
//     *
//     * @return self
//     */
//    public function removeProject($project);
}

src/CentraleLille/CustomFosUserBundle/Form/ProfileType.php
<?php

namespace CentraleLille\CustomFosUserBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class ProfileType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {

        $builder
            ->remove('current_password')
            ->add('email', 'email', array('label' => 'Email'))
            ->add('promo', null, array('label' => 'Promotion'))
            ->add('phone', null, array('label' => 'Téléphone'));
    }

    public function getParent()
    {
        return 'FOS\UserBundle\Form\Type\ProfileFormType';

        // Or for Symfony < 2.8
        // return 'fos_user_registration';
    }

    public function getBlockPrefix()
    {
        return 'app_user_profile';
    }

    // For Symfony 2.x
    public function getName()
    {
        return $this->getBlockPrefix();
    }
}

src/CentraleLille/CustomFosUserBundle/Controller/DefaultController.php
<?php

namespace CentraleLille\CustomFosUserBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;

class DefaultController extends Controller
{
    /**
     * @Route("/")
     */
    public function indexAction()
    {
        $users = $this
            ->getDoctrine()
            ->getManager()
            ->getRepository('CustomFosUserBundle:User')
            ->findAll();

        $projects = $this
            ->getDoctrine()
            ->getManager()
            ->getRepository('CustomFosUserBundle:Project')
            ->findAll();

        $currentUser = $this->getUser();

        return $this->render(
            'CustomFosUserBundle:Default:index.html.twig',
            array(
            'users' => $users,
            'currentUser' => $currentUser,
            'projects' => $projects
            )
        );
    }
}

src/CentraleLille/CustomFosUserBundle/Resources/views/Default/index.html.twig
{% extends 'layout.html.twig' %}

{% block body %}
<br><br><br>
<div class="container-fluid">
<h2>Utilisateurs</h2>
{% if currentUser %}
<p> Vous êtes connecté en tant que : <strong>{{ currentUser.username }}</strong></p>
{% endif %}
<table class="table table-striped">
    <tr>
        <th>Username</th>
        <th>Projects</th>
        <th>Roles</th>
    </tr>
    {% for user in users %}
    <tr>
       <td style="vertical-align: middle">{{ user.username }}</td>
       <td style="vertical-align: middle">
       {% for pu in user.projectUsers %}
           {{ pu.project.name }}
           (<a href="{{ path('project_show', {'projectId' : pu.project.id}) }}">view</a> /
           <a href="{{ path('project_edit', {'projectId' : pu.project.id}) }}">edit</a>)
           <br>
       {% endfor %}
       </td>
       <td style="vertical-align: middle">
           <b>Global: </b>
           {% for role in user.roles %}
               {{role}}
               {% if not loop.last %}
                 -
                {% endif %}
           {% endfor %}
           <br>
           {% for pu in user.projectUsers %}
               {% if pu.roles is not empty %}
                   <b>{{ pu.project.name }}: </b>
                   {% for pRole in pu.roles %}
                       {{ pRole.name }}
                       {% if not loop.last %}
                           -
                       {% endif %}
                   {% endfor %}
                   <br>
               {% endif %}
           {% endfor %}
       </td>
    </tr>
    {% endfor %}
</table>

<h2>Projets</h2>
    <table class="table table-striped">
        <tr>
            <th>Nom du projet</th>
        </tr>
        {% for project in projects %}
            <tr>
                <td>{{ project.name }}
                    (<a href="{{ path('project_show', {'projectId' : project.id}) }}">view</a> /
                    <a href="{{ path('project_edit', {'projectId' : project.id}) }}">edit</a>)
                </td>
            </tr>
        {% endfor %}
    </table>
</div>
{% endblock %}